#!/ysr/bin/env python
#-*- coding:utf-8 -*-
__author__ = "yua"

import os, platform, socket
import subprocess


class RunCmd(object):
    def __init__(self):
        pass

    def run_command(self, command):
        """
        执行系统命令
        :param command: string
        :return: boolean
        """
        status, out_info = subprocess.getstatusoutput(command)
        if status == 0:
            return True
        else:
            return False

    def run_command_return_output(self, command):
        """
        执行系统命令
        :param command: string
        :return: string
        """
        status, out_info = subprocess.getstatusoutput(command)
        if status == 0:
            return out_info
        else:
            return False

class GetInstanceInfo(object):
    def __init__(self):
        self.obj_runcmd = RunCmd()

    def get_instance_system_type(self):
        """
        获取实例 操作系统类型
        :return: string (Linux/Windows)
        """
        return platform.system()

    def get_instance_uuid(self):
        """
        获取实例 uuid
        :return: string
        """
        if self.get_instance_system_type() == "Linux":
            return self.obj_runcmd.run_command_return_output('dmidecode --string system-uuid')
        return False

    def get_instance_cloud_type(self):
        """
        获取实例 所在的公有云或者机房
        :return: string (aws/intranet)
        """
        uuid = self.get_instance_uuid()
        if uuid[0:3].lower() == "EC2":
            return 'aws'
        else:
            return 'intranet'

    def get_instance_hostname(self):
        """
        获取实例 主机名
        :return: string
        """
        return socket.gethostname()

    def get_instance_private_ip(self):
        """
        获取实例 内网私有IP
        :return: string
        """
        if self.get_instance_system_type() == 'Linux' and self.get_instance_cloud_type() == 'aws':
            return self.obj_runcmd.run_command_return_output('curl http://169.254.169.254/latest/meta-data/local-ipv4').split()[-1]
        else:
            s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
            s.connect(('8.8.8.8', 80))
            ip = s.getsockname()[0]
            s.close()
            return ip

    def get_instance_id(self):
        """
        获取 实例ID 内网机器则返回 主机名
        :return: string
        """
        if self.get_instance_system_type() == 'Linux' and self.get_instance_cloud_type() == 'aws':
            return self.obj_runcmd.run_command_return_output('curl http://169.254.169.254/latest/meta-data/instance-id').split()[-1]
        else:
            return self.get_instance_hostname()